print("Loading MtgJSON file....")
mtgjson = io.open("AllPrintings.json"):read("*all")
print("Loading Penny Dreadful legal cards file....")
legalcards = io.open("legal_cards.txt","r")
pennydreadful = io.open("Penny Dreadful.txt","w")

pennydreadful:write("[metadata]\nCode=PPD\nDate=".. os.date("%Y-%m-%d").. "\nName=Penny Dreadful\nMciCode=ppd\nType=core\n\n[cards]\n")
cardNumber = 1
cardTable = {}
while true do
	i, j = string.find(mtgjson, "\"isMtgo\".-\"rulings\"", j) 	--find the truncated entry for the card (dirty, but faster than doing a full json parse)
	if i  == nil then break end									--break if there are no further card entries
	cardEntry = string.sub(mtgjson, i, j)
	cardName = string.match(cardEntry, '"name": "(.-)",')		--extract the card name
	if cardName ~= cardNameOld then								--sometimes there are promo versions of cards, no need to do it twice
		splitA, splitB = string.match(cardEntry, '"names"..."(.+)", "(.+)"..."number"')		--if it's a split card, get the two names
		cardRarity = string.match(cardEntry,'"rarity.-\"(%a)')								--extract the rarity
		if cardRarity ~= nil then
			cardTable[cardName] = string.upper(cardRarity)									--create an index entry of the card name with rarity
			print (cardNumber .. " - Indexing Card: " .. cardName)
			if splitA ~= nil then
				cardName = splitA .. " split " .. splitB									--replace "//" with split in card names
				cardTable[cardName] = string.upper(cardRarity)								--index the split card
				print(cardNumber .. " - Indexing Card: " .. splitA .. " // " .. splitB)
			end
		end
	end
	cardNumber = cardNumber + 1
	cardNameOld = cardName
end

errorCards = ""
errorCount = 0
cardNumber = 1

while true do
        cardName = legalcards:read("*line")
		if cardName == nil then break end
		cardNameClean = cardName
		cardNameClean = string.gsub(cardNameClean,"'","\'")				--excape special characters
		cardNameClean = string.gsub(cardNameClean,'"','\"')				--excape special characters
		cardNameClean = string.gsub(cardNameClean,"//","split")			--replace // with split in card name
		cardRarity = cardTable[cardNameClean]						--look up the rarity in the index
		if cardRarity == nil then									--basic error handling
			print("ERROR - Cannot find card rarity: ",cardName, cardNameClean)
			errorCount = errorCount +1
			errorCards  = errorCards  .. cardName .. "\n"
			cardRarity = "U"										--default rarity to uncommon if unknown
			end
		print(cardNumber .. " - Adding card to database: " .. cardName)
		pennydreadful:write(cardRarity .. " " ..  cardName .. "\n")	
		cardNumber = cardNumber + 1
end

print("Errors with the following ",errorCount," card(s): ",errorCards)
print("\n")